Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 6632)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 6633)
@@ -211,8 +211,9 @@
         student_id = self.request.form.get('form.student_id')
         student = createObject(u'waeup.Student')
+        student.student_id = student_id
         self.applyData(student, **data)
         #import pdb; pdb.set_trace()
         try:
-            self.context[student_id] = student
+            self.context.addStudent(student)
         except KeyError:
             self.flash('The student id chosen already exists.')
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/container.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/container.py	(revision 6632)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/container.py	(revision 6633)
@@ -21,5 +21,7 @@
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
-from waeup.sirp.students.interfaces import IStudentsContainer
+from waeup.sirp.students.interfaces import (
+    IStudentsContainer, IStudent)
+from waeup.sirp.students.studycourse import StudentStudyCourse
 
 class StudentsContainer(grok.Container):
@@ -35,16 +37,12 @@
     def clear(self, id=None, archive=True):
         raise NotImplementedError()
-    
-class StudentsContainerFactory(grok.GlobalUtility):
-    """A factory for students containers.
-    """
-    grok.implements(IFactory)
-    grok.name(u'waeup.StudentsContainer')
-    title = u"Create a new students container.",
-    description = u"This factory instantiates new students containers."
 
-    def __call__(self, *args, **kw):
-        return StudentsContainer()
-
-    def getInterfaces(self):
-        return implementedBy(StudentsContainer)
+    def addStudent(self, student):
+        """Add a student with subcontainers.
+        """
+        if not IStudent.providedBy(student):
+            raise TypeError('StudentsContainers contain only IStudent instances')
+        self[student.student_id] = student
+        studycourse = StudentStudyCourse()
+        self[student.student_id]['studycourse'] = studycourse
+        return
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 6632)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 6633)
@@ -47,4 +47,9 @@
     """
 
+    def addStudent(faculty):
+        """Add an IStudent object and subcontainers.
+
+        """
+
     def archive(id=None):
         """Create on-dist archive of students.
@@ -76,2 +81,13 @@
         database.
         """
+
+class IStudentStudyCourse(IWAeUPObject):
+    """A container for student study levels.
+
+    """
+
+    certificate_code = schema.TextLine(
+        title = u'Certificate Code',
+        default = u'None',
+        required = True,
+        )
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/studycourse.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/studycourse.py	(revision 6633)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/studycourse.py	(revision 6633)
@@ -0,0 +1,37 @@
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+"""
+Container which holds the data of the student study courses
+and contains the (student) study level objects.
+"""
+import grok
+from grok import index
+from zope.component.interfaces import IFactory
+from zope.interface import implementedBy
+from waeup.sirp.students.interfaces import IStudentStudyCourse
+from waeup.sirp.utils.helpers import attrs_to_fields
+
+class StudentStudyCourse(grok.Container):
+    """This is a container for study levels.
+    """
+    grok.implements(IStudentStudyCourse)
+    grok.provides(IStudentStudyCourse)
+
+    def __init__(self):
+        super(StudentStudyCourse, self).__init__()
+        return
+
+StudentStudyCourse = attrs_to_fields(StudentStudyCourse)
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_container.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_container.py	(revision 6632)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_container.py	(revision 6633)
@@ -25,5 +25,5 @@
     )
 from waeup.sirp.students.container import (
-    StudentsContainer, StudentsContainerFactory,
+    StudentsContainer, 
     )
 from waeup.sirp.testing import FunctionalLayer
@@ -50,24 +50,2 @@
         self.assertRaises(
             NotImplementedError, container.clear)
-
-class StudentsContainerFactoryTest(FunctionalTestCase):
-
-    layer = FunctionalLayer
-
-    def setUp(self):
-        self.factory = StudentsContainerFactory()
-
-    def tearDown(self):
-        pass
-
-    def test_interfaces(self):
-        verifyClass(IFactory, StudentsContainerFactory)
-        verifyObject(IFactory, self.factory)
-
-    def test_factory(self):
-        obj = self.factory()
-        assert isinstance(obj, StudentsContainer)
-
-    def test_getInterfaces(self):
-        implemented_by = self.factory.getInterfaces()
-        assert implemented_by.isOrExtends(IStudentsContainer)
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_student.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_student.py	(revision 6632)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_student.py	(revision 6633)
@@ -30,6 +30,9 @@
     Student, StudentFactory,
     )
+from waeup.sirp.students.studycourse import (
+    StudentStudyCourse,
+    )
 from waeup.sirp.students.interfaces import (
-    IStudent,
+    IStudent, IStudentStudyCourse,
     )
 from waeup.sirp.testing import FunctionalLayer
@@ -42,4 +45,5 @@
         super(StudentTest, self).setUp()
         self.student = Student()
+        self.studycourse = StudentStudyCourse()
         return
 
@@ -51,4 +55,6 @@
         verify.verifyClass(IStudent, Student)
         verify.verifyObject(IStudent, self.student)
+        verify.verifyClass(IStudentStudyCourse, StudentStudyCourse)
+        verify.verifyObject(IStudentStudyCourse, self.studycourse)
         return
 