Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/sitelayout.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/sitelayout.pt	(revision 6638)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/sitelayout.pt	(revision 6639)
@@ -1,111 +1,90 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
-	  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
   <head>
-    <title>WAeUP - your way up</title>
+    <title>WAeUP - your way up
+    </title>
     <!--base href="http://localhost:8080/app/@@page"
-	  tal:attributes="href python: view.url(layout.site)" / -->
+     tal:attributes="href python: view.url(layout.site)" / -->
     <meta http-equiv="content-type" content="text/html; charset=UTF-8" />
     <meta name="robots" content="index, follow" />
-
-    <link rel="shortcut icon" tal:attributes="href static/favicon.ico" 
-	  type="image/x-icon" />
-
-    <link rel="alternate" type="application/rss+xml"
-	  title="RSS" href="http://www.example.net/feed.rss"
-	  tal:attributes="title string:RSS feed of ${layout/getAppTitle};
-			  href python: view.url(layout.site, 'feed.rss')" />
-
+    <link rel="shortcut icon" tal:attributes="href static/favicon.ico" type="image/x-icon" />
+    <link rel="alternate" type="application/rss+xml" title="RSS"
+        href="http://www.example.net/feed.rss"
+        tal:attributes="title string:RSS feed of ${layout/getAppTitle};
+            href python: view.url(layout.site, 'feed.rss')" />
   </head>
   <body class="rounded yui-skin-sam">
     <div id="doc3" class="yui-t1">
       <div id="hd" role="banner">
-	<div id="hd">
-
-	  <h1 id="logo">
-	    <a href=""
-	       tal:attributes="href view/application_url">
-	        <span class="uni-logo"></span>
-	    </a>
-	    <span id="uni-title" tal:content="layout/getAppTitle">
-	      Sample University
-	    </span>
-	  </h1>
-
-	  <div id="navigation" class="yui-navset" style="text-align:right;">
-
-	    <ul id="primary-navigation">
-	      <tal:primary_nav content="structure provider:primary_nav" />
-	    </ul>
-
-	    <ul id="user-navigation"
-		tal:condition="layout/isAuthenticated">
-	      <li>
-		<a href="#"
-		   tal:attributes="href python: view.url(layout.site,
-		   '@@contactadmin')">Contact</a>
-	      </li>
-	      <li>
-		<a href="#"
-		   tal:attributes="href python: view.url(context,
-		   '@@logout')">Logout</a>
-	      </li>
-	    </ul>
-	    <div class="clear"></div>
-	    
-	  </div>
-	</div>
-	
+        <div id="hd">
+          <h1 id="logo">
+            <a href="" tal:attributes="href view/application_url">
+              <span class="uni-logo">
+              </span> </a>
+            <span id="uni-title" tal:content="layout/getAppTitle"> Sample University
+            </span> </h1>
+          <div id="navigation" class="yui-navset" style="text-align:right;">
+            <ul id="primary-navigation">
+              <tal:primary_nav content="structure provider:primary_nav" />
+            </ul>
+            <ul id="user-navigation" tal:condition="layout/isAuthenticated">
+              <li>
+              <a href="#" tal:attributes="href python: view.url(layout.site, '@@contactadmin')">
+                  Contact
+              </a>
+              </li>
+              <li>
+              <a href="#" tal:attributes="href python: view.url(context, '@@logout')">Logout</a>
+              </li>
+            </ul>
+            <div class="clear">
+            </div>
+          </div>
+        </div>
       </div>
       <div id="bd" role="main">
-      <span tal:condition="layout/isAuthenticated" tal:content="structure provider:breadcrumbs" />
-	<div id="yui-main">
-	  <div class="yui-b"><div class="yui-g">
-	      
-	      
-
-	      <div class="block">
-		<div class="hd">
-		  <h2 tal:content="view/title"> 
-		    THE CONTENT TITLE
-		  </h2>
-		</div>
-		<div class="bd">
-		  <div class="actionbar">
-		    <tal:actionbar content="structure provider:actionbar" />
-		  </div>
-
-		  <div class="alert warning ui-state-error"
-		       tal:define="message context/@@messages"
-		       tal:condition="python: len(message)>11">
-		    <span class="ui-icon ui-icon-alert">A</span>
-		    <span tal:content="structure message"></span>
-		  </div>
-
-		  <div tal:replace="structure view/content">
-		    THE CONTENT
-		  </div>
-
-		</div>
-	      </div>
-
-	    </div>
-	  </div>
-	</div>
-	<div class="yui-b">
-	  <div class="block">
-	    <div class="hd">
-	      <h2 tal:content="layout/getUserTitle">Username</h2>
-	    </div>
-	    <div class="bd">
-	      <tal:left content="structure provider:left" />
-	    </div>
-	  </div>
-	</div>
+        <span tal:condition="layout/isAuthenticated"
+              tal:content="structure provider:breadcrumbs" />
+        <div id="yui-main">
+          <div class="yui-b">
+            <div class="yui-g">
+              <div class="block">
+                <div class="hd">
+                  <h2 tal:content="view/title"> THE CONTENT TITLE </h2>
+                </div>
+                <div class="bd">
+                  <div class="actionbar">
+                    <tal:actionbar content="structure provider:actionbar" />
+                  </div>
+                  <div class="alert warning ui-state-error"
+                      tal:define="message context/@@messages"
+                      tal:condition="python: len(message)>11">
+                    <span class="ui-icon ui-icon-alert">A
+                    </span>
+                    <span tal:content="structure message">
+                    </span>
+                  </div>
+                  <div tal:replace="structure view/content"> THE CONTENT
+                  </div>
+                </div>
+              </div>
+            </div>
+          </div>
+        </div>
+        <div class="yui-b">
+          <div class="block">
+            <div class="hd">
+              <h2 tal:content="layout/getUserTitle">Username</h2>
+            </div>
+            <div class="bd">
+              <tal:left content="structure provider:left" />
+            </div>
+          </div>
+        </div>
       </div>
-
       <div id="ft" role="contentinfo">
-	<p>Student Information and Registration Portal<br /> 
-	Copyright &copy; WAeUP Group, 2008-2010</p>
+        <p>Student Information and Registration Portal<br />
+            Copyright &copy; WAeUP Group, 2008-2010
+        </p>
       </div>
     </div>