Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 6659)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 6660)
@@ -76,5 +76,5 @@
     grok.context(IWAeUPObject)
     grok.order(3)
-    grok.require('waeup.viewStudents')
+    grok.require('waeup.viewStudent')
     grok.template('primarynavtab')
 
@@ -115,5 +115,5 @@
     grok.context(IStudentsContainer)
     grok.name('index')
-    grok.require('waeup.viewStudents')
+    grok.require('waeup.viewStudent')
     grok.template('studentscontainerpage')
     label = 'Student Section'
@@ -231,5 +231,5 @@
     grok.context(IStudent)
     grok.name('index')
-    grok.require('waeup.viewStudents')
+    grok.require('waeup.viewStudent')
     grok.template('studentpage')
     form_fields = grok.AutoFields(IStudentBase)
@@ -299,5 +299,5 @@
     grok.context(IStudent)
     grok.name('view_clearance')
-    grok.require('waeup.viewStudents')
+    grok.require('waeup.viewStudent')
     form_fields = grok.AutoFields(IStudentClearance)
     form_fields['date_of_birth'].custom_widget = FriendlyDateDisplayWidget('le')
@@ -339,5 +339,5 @@
     grok.context(IStudent)
     grok.name('view_personal')
-    grok.require('waeup.viewStudents')
+    grok.require('waeup.viewStudent')
     form_fields = grok.AutoFields(IStudentPersonal)
     title = 'Personal Data'
@@ -361,5 +361,5 @@
     grok.context(IStudent)
     grok.name('edit_personal')
-    grok.require('waeup.viewStudents')
+    grok.require('waeup.viewStudent')
     form_fields = grok.AutoFields(IStudentPersonal)
     label = 'Edit personal data'
@@ -372,5 +372,5 @@
     grok.context(IStudentStudyCourse)
     grok.name('index')
-    grok.require('waeup.viewStudents')
+    grok.require('waeup.viewStudent')
     form_fields = grok.AutoFields(IStudentStudyCourse)
     #grok.template('studycoursepage')
@@ -407,5 +407,5 @@
     grok.context(IStudentPayments)
     grok.name('index')
-    grok.require('waeup.viewStudents')
+    grok.require('waeup.viewStudent')
     form_fields = grok.AutoFields(IStudentPayments)
     #grok.template('paymentspage')
@@ -422,5 +422,5 @@
     grok.context(IStudentAccommodation)
     grok.name('index')
-    grok.require('waeup.viewStudents')
+    grok.require('waeup.viewStudent')
     form_fields = grok.AutoFields(IStudentAccommodation)
     #grok.template('accommodationpage')
@@ -437,5 +437,5 @@
     grok.context(IStudent)
     grok.name('history')
-    grok.require('waeup.viewStudents')
+    grok.require('waeup.viewStudent')
     grok.template('studenthistory')
     title = 'History'
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/permissions.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/permissions.py	(revision 6659)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/permissions.py	(revision 6660)
@@ -21,9 +21,18 @@
 # Student section permissions
 
-class ViewStudents(grok.Permission):
-    grok.name('waeup.viewStudents')
+class HandleStudent(grok.Permission):
+    grok.name('waeup.handleStudent')
+
+class ViewStudent(grok.Permission):
+    grok.name('waeup.viewStudent')
 
 class ManageStudents(grok.Permission):
     grok.name('waeup.manageStudents')
+
+# Local role
+class StudentRecordOwner(grok.Role):
+    grok.name('waeup.local.StudentRecordOwner')
+    grok.title(u'Student Record Owner')
+    grok.permissions('waeup.handleStudent', 'waeup.viewStudent')
 
 # Global Roles
@@ -32,3 +41,3 @@
     grok.title(u'Students Officer')
     grok.permissions('waeup.View', 'waeup.Public',
-                     'waeup.viewStudents', 'waeup.manageStudents')
+                     'waeup.viewStudent', 'waeup.manageStudents')
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/viewlets.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/viewlets.py	(revision 6659)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/viewlets.py	(revision 6660)
@@ -9,5 +9,5 @@
 
 class StudentLink(grok.Viewlet):
-    """A link displayed in the student box which shows for StudentNavigation
+    """A link displayed in the student box which shows up for StudentNavigation
     objects.
 
@@ -18,5 +18,5 @@
     grok.view(Interface)
     grok.order(5)
-    grok.require('waeup.viewStudents')
+    grok.require('waeup.viewStudent')
 
     link = 'index'